# Autogenerated file. Changes will be overwritten.

try:
    import coriolis
except ImportError:
    import CRL, Hurricane, Viewer, Cfg
    from Hurricane import (
        Technology, DataBase, DbU, Library,
        Layer, BasicLayer,
        Cell, Net, Horizontal, Vertical, Rectilinear, Box, Point,
        Instance, Transformation,
        NetExternalComponents,
    )
    from helpers import u, l
    from helpers.technology import setEnclosures
    from helpers.overlay import CfgCache, UpdateSession
else:
    from coriolis import CRL, Hurricane, Viewer, Cfg
    from coriolis.Hurricane import (
        Technology, DataBase, DbU, Library,
        Layer, BasicLayer,
        Cell, Net, Horizontal, Vertical, Rectilinear, Box, Point,
        Instance, Transformation,
        NetExternalComponents,
    )
    from coriolis.helpers import u, l
    from coriolis.helpers.technology import setEnclosures
    from coriolis.helpers.overlay import CfgCache, UpdateSession

__all__ = ["setup"]

def createRL(tech, net, layer, coords):
    coords = [Point(u(x), u(y)) for x,y in coords]
    Rectilinear.create(net, tech.getLayer(layer), coords)

def _routing():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()

    # No standard cell library
    pass


def _load():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()
    rootlib = db.getRootLibrary()

    lib = Library.create(rootlib, 'MacroLib')
    new_cells = {
        'NPN_05v5_W1u00L1u00': Cell.create(lib, 'NPN_05v5_W1u00L1u00'),
        'NPN_05v5_W1u00L2u00': Cell.create(lib, 'NPN_05v5_W1u00L2u00'),
        'PNP_05v5_W0u68L0u68': Cell.create(lib, 'PNP_05v5_W0u68L0u68'),
        'PNP_05v5_W3u40L3u40': Cell.create(lib, 'PNP_05v5_W3u40L3u40'),
    }
    # Export failed for cell 'NPN_05v5_W1u00L1u00'# Export failed for cell 'NPN_05v5_W1u00L2u00'# Export failed for cell 'PNP_05v5_W0u68L0u68'# Export failed for cell 'PNP_05v5_W3u40L3u40'
    af.wrapLibrary(lib, 0)

    return lib

def setup():
    lib = _load()
    _routing()
    try:
        from .MacroLib_fix import fix
    except:
        pass
    else:
        fix(lib)

    return lib
